MGT  = {}
MGT.Version = '4.00.00'

--[[ Data structures
  templates
  	 {
					groupName 	
				,	displayName	
				,	category	
        ,	subCategory	
				,	side 		   
				,	era 		   
				,	disperse 	  
				, size		    
				,	properties (table, free format)	 
			}		



]]--



--###################################################################################################################################################
-- #############	DCS - Mission Generator  Tool																					                                           	################# 
-- #############	by Draken35																										                                                    ################# 
--###################################################################################################################################################
--[[ Requirements:	
		>>>	 MIST 4.5.107 or above <https://github.com/mrSkortch/MissionScriptingTools/tree/master>
    >>> d35lib 1.00.00 or above
--]]
-------

--###################################################################################################################################################
-- #############   Configuration section   																							                                            ################# 
--###################################################################################################################################################
do

  MGT.Era	= 0 	


  MGT.messageBeep = '204521__redoper__roger-beep.ogg' -- Message alert sound. leave empty for no sound

end
--#################################################################################################################################################
-- #############   Initialization of globals (infrastructure)																		                                    ############### 
--#################################################################################################################################################
do
  MGT.populatedUnitPositions = {}
  MGT.templateList = {}
end
----------------------------------------------------------------------------------------------------------------------------------------------

--#################################################################################################################################################
-- #############   code	lib													 	  									                                                  				############### 
--#################################################################################################################################################

function MGT.populateLand(_templateList, _quantity, _center, _borderGrpName, _minRadius, _maxRadius, _minAngle,_maxAngle, _distanceBetween, _offsetRoute, _terrainList, _attempts)
	local border = mist.getGroupPoints(_borderGrpName)
	--local targetZone = trigger.misc.getZone(_zoneName)
	local _action = 'clone'
	local retPos = nil
	local minRad = _minRadius
	local maxRad = _maxRadius
	local grpList = {}
	
	local nt = d35.rowCount(_templateList)
	local n = _quantity
	
	local offsetRoute = true
	if _offsetRoute ~= nil then
		offsetRoute = _offsetRoute
	end

	local disperse 
	local maxdis 
  local terrainList = _terrainList
  if  terrainList == nil then
    terrainList = {'LAND','ROAD'}
  end
	
	while n > 0 and nt > 0 do
		--env.error('populateLand() quantity:'.. n,false)
		retPos = nil
		temp = _templateList[mist.random(1,nt)]
		disperse =  temp.disperse > 0
		maxdis = temp.disperse 
		local placed = false
		local attempts = _attempts
    if attempts == nil then
      attempts = 50
    end
		local fail_v = 0
		local fail_f = 0
		local fail_i = 0
		local fail_c = 0
		local fail_e = 0
		while not placed and attempts > 0 do
		--	env.error('populateLand() attempt:'.. attempts,false)
			attempts = attempts - 1
			local rp 
			if maxRad == 0 and  minRad == 0 then
					rp = _center
			else	
				if _minAngle == _maxAngle then
					rp = mist.getRandPointInCircle(_center ,maxRad , minRad)
				else
					rp = mist.getRandPointInCircle(_center ,maxRad , minRad ,_maxAngle ,_minAngle )
				end
			end
			local inside =  mist.pointInPolygon(rp,border)
			if inside then
				--env.error('populateLand() inside',false)
				if mist.isTerrainValid(rp, terrainList) == true then 
					--env.error('populateLand() land',false)
					if (temp.size == 0) or (mist.terrainHeightDiff(rp,temp.size) < math.floor(0.4 * temp.size*10)) then
						--env.error('populateLand() flat',false)
						if MGT.isAreaEmpty(rp,temp.size) then
							--env.error('populateLand() empty',false)
							local objs = MGT.populatedUnitPositions
							local good = true
							local num_objs =  d35.rowCount(objs)	
							if num_objs > 0 then
								local i = 1
								while i <= num_objs and good do
								
									local d = mist.utils.get2DDist(rp,objs[i])
									if d <= _distanceBetween then -- distance between units
										good = false
									end
																				
									i = i + 1
								end -- while								
							end
									
							if good then
								--env.error('populateLand() good',false)
								table.insert(MGT.populatedUnitPositions, rp) 
								retPos = rp
								rp = mist.utils.makeVec3GL(rp)
								local gn = string.format('%s_%s',temp.groupName,d35.getNextID())
								local newgrp = mist.teleportToPoint({
									groupName = temp.groupName, 
									point = rp, 
									action = _action,
									newGroupName = gn,
									disperse = disperse,
									maxDisp = maxdis,
									offsetRoute = offsetRoute
                  --offsetWP1 = offsetRoute,
                  
								})
								if newgrp then
									local g = Group.getByName(gn)
									g:activate()
									local row = {name = gn, pos = retPos, template = temp}
									table.insert(grpList, row)
									placed = true
									n = n - 1
									env.error(string.format('populateLand() : N:%s, S:%s, A:%s -> deployed as %s',temp.groupName,temp.size,attempts,gn),false)
								end
							else -- too close
								fail_c = fail_c + 1
							end
						else -- if MGT.isAreaEmpty() then
							fail_e = fail_e + 1
							--env.error(string.format('populateLand() : N:%s, S:%s, A:%s -> Area not empty',temp.groupName,temp.size,attempts))
						end -- if MGT.isAreaEmpty() then
					else -- if mist.terrainHeightDiff(rp,10) 
						fail_f = fail_f + 1
						--env.error(string.format('populateLand() : N:%s, S:%s, A:%s -> Area not flat',temp.groupName,temp.size,attempts))
					end -- if mist.terrainHeightDiff(rp,10) 
				else  -- if mist.isTerrainValid(rp, {'LAND'}) 
					fail_v = fail_v + 1
					--env.error(string.format('populateLand() : N:%s, S:%s, A:%s -> Area not valid',temp.groupName,temp.size,attempts))
				end -- if mist.isTerrainValid(rp, {'LAND'}) 
			else-- if inside
				fail_i = fail_i + 1
				--env.error(string.format('populateLand() : N:%s, S:%s, A:%s -> Area not inside',temp.groupName,temp.size,attempts))
			end -- if inside 
		end -- while surfType == 3 do
	    if attempts == 0 then
			n = n - 1
			env.error(string.format('populateLand() : N:%s, S:%s, A:%s  i:%s / v:%s / f:%s / e:%s / c:%s   -> skipped',temp.groupName,temp.size,attempts,fail_i,fail_v,fail_f,fail_e,fail_c),false)
		end
	end -- while not placed and attempts <= 5 do
	return  grpList
end
--===================================================================================================================================================
function MGT.populateAir(_templateList, _quantity, _center, _borderGrpName, _minRadius, _maxRadius, _minAngle,_maxAngle, _offsetRoute)
	local border = mist.getGroupPoints(_borderGrpName)
	--local targetZone = trigger.misc.getZone(_zoneName)
	local retPos = nil
	local minRad = _minRadius
	local maxRad = _maxRadius
	local grpList = {}
	
	local nt = d35.rowCount(_templateList)
	local n = _quantity
	

	local offsetRoute = true
	if _offsetRoute ~= nil then
		offsetRoute = _offsetRoute
	end

	local disperse 
	local maxdis 

	
	while n > 0 and nt > 0 do
		retPos = nil
		temp = _templateList[mist.random(1,nt)]
		disperse =  temp.disperse > 0
		maxdis = temp.disperse 
		local placed = false
		local attempts = 20
		while not placed and attempts > 0 do
			attempts = attempts - 1
			local rp 
			if _minAngle == _maxAngle then
				rp = mist.getRandPointInCircle(_center ,maxRad , minRad)
			else
				rp = mist.getRandPointInCircle(_center ,maxRad , minRad ,_maxAngle ,_minAngle )
			end
			--surfType= land.getSurfaceType(rp)
			local inside =  mist.pointInPolygon(rp,border)

			if inside then
				retPos = rp
				local gn = string.format('%s_%s',temp.groupName,d35.getNextID())
				local newgrp = mist.teleportToPoint({
					groupName = temp.groupName, 
					point = rp, 
					action = 'clone',
					newGroupName = gn,
					disperse = disperse,
					maxDisp = maxdis,
					offsetRoute = offsetRoute
				})
				if newgrp then
					local g = Group.getByName(gn)
					g:activate()
					local row = {name = gn, pos = retPos, template = temp}
					table.insert(grpList, row)
					placed = true
					n = n - 1
				end

			
			end -- if inside 
		end --while not placed and attempts > 0 do
	    if attempts == 0 then
			n = n - 1
		end
	end --while n > 0 do
	return  grpList
end
--===================================================================================================================================================
function MGT.isAreaEmpty(_center,_radius)
	local ret = true
	if _radius < 35 then
		_radius = 35
	end
	
	local foundObjs = {}
	
	local volS = {
	   id = world.VolumeType.SPHERE,
	   params = {
		 point = _center,
		 radius = _radius
	   }
	 }
	local ifFound = 
		function(foundItem, val)
			foundObjs[#foundObjs + 1] = foundItem
			return true
		end

	world.searchObjects(Object.Category.SCENERY, volS, ifFound)
	ret = d35.rowCount(foundObjs) == 0 

	return ret
end -- function
--===================================================================================================================================================
function MGT.addTemplate(_groupName, _displayName, _category, _side, _era, _disperse, _size,  _properties)
	local row = {
					groupName 	= _groupName
				,	displayName	= _displayName
				,	category	  = _category
				,	side 		    = _side
				,	era 		    = _era
				,	disperse 	  = _disperse
				, size		    = _size
				, properties  = _properties
			}		
	MGT.templateList[_groupName] = row

end --function
--===================================================================================================================================================
function MGT.getTemplateList (_categoryTable, _side, _era)
	local list = {}
	local n = 0
	for id,row in pairs(MGT.templateList) do
		if d35.inTable(row.category,_categoryTable) or (_categoryTable == {}) then
			if (row.side == _side) then
				if (row.era == _era) or (row.era == 0)  then
					n = n + 1
					 list[n] = row
				end --if (row.era == _era) or (_era == nil) then
			end-- if (row.side == _side) or (_side == nil) then
		end -- if d35.inTable(row.category,_categoryTable) or (_categoryTable = {}) then
	end -- for id,row in MGT.templateList do
	if n == 0 then
		local msg = 'side:<'.._side..'> era:<'.._era..'> cat. table:'
		if _categoryTable == {} then
			msg = msg..' empty!'
		else
			for _,v in pairs(_categoryTable ) do
				msg = msg..'<'..v..'>'
			end
		end
		env.error('MGT.getTemplateList: search returned 0 values! '..msg ,false)
	end
	return list, n
end -- function

--===================================================================================================================================================
--
--#################################################################################################################################################
-- #############   Main body   																										                                                  ############### 
--#################################################################################################################################################
--
do

	trigger.action.outText( 'MGT - v'..MGT.Version, 1 )
end






